          SECTION C                                               FILE EXTRA.C
                               Making a Start-of Day disc
                               **************************

              If you intend to spend some time with MALLARD BASIC it is worth
          making a Start-of-Day disc. This is a disc which contains all the
          files which you are likely to need when working with MALLARD BASIC.
          The ultimate choice of files and facilities depends on your personal
          preference, but in this file I want to show you how to make an auto-
          loading Start-of Day disc, which when inserted into the A drive, not
          only boots CP/M but also transfers selected files to the M drive and
          makes them easily available, dedicates keys to Mallard, sets the
          printer to a suitable  typestyle, sets up your paper parameters to
          use 11" continuous paper and loads BASIC, thus enabling you to get a
          flying start into a BASIC programming session.
              This file first takes you mechanically through the steps
          necessary to make a practical Start-of Day disc to suit MALLARD
          BASIC, and then goes on to discuss the process more thoroughly so
          that you can modify the disc, if you wish, to make it more suitable
          for your own particular needs.
              The same procedure can be followed to make a Start of Day disc
          for any specialised activity
              The first requirement is a blank CF2 disc, formatted by DISCKIT
          for the A drive. Most of the files needed to make the Start-of Day
          disc will be found on your master CP/M disc. Check with DIR.  They
          are:-

              J14CPM3.EMS (or similar, depending on your version of CP/M)
              PIP.COM
              BASIC.COM
              SETKEYS.COM
              SUBMIT.COM
              PAPER.COM
              SETLST.COM

          The remaining files will be found on this disc :-

              PROFILE.SUB
              KEYS.MB
              PRINTER.SET
              NSWP.COM
              FIND.COM

          Making the auto-loading Start-of Day disc just involves copying all
          these files to the blank disc and this can be done using PIP.COM or
          NSWP.COM. (See the documentation for NSWP.COM in EXTRA, section e).
          The easiest way to do this is to copy them all to the M drive and
          from there to the blank disc in the A drive.
              It is best if the M drive is empty at this time and the machine
          is set to it's standard defaults, and the best way to achieve this
          is to start from scratch. So switch on your machine, put your master
          CP/M disc (or more properly a copy of it) into the A drive and boot
          CP/M.

          COPYING FILES WITH PIP.COM
          **************************      At the A> prompt type pip and press
          [RETURN]. An asterisk will appear at which you type
          M:=A:J14CPM3.EMS. The screen now looks like this :-

          A> pip
          * m:=a:j14cpm3.ems   ... note that you can use upper or lower case.

          When you press [RETURN], file J14CPM3.EMS will be copied to the M
          drive and another asterisk will appear. Against this type :-
              m:=a:pip.com and press [RETURN]to copy PIP.COM similarly.
          Carry on in this way until all the above files on the CP/M master
          disc have been copied to the M drive, then remove the disc from the
          drive and replace it with the disc containing the other files;
          PROFILE.SUB, KEYS.MB, PRINTER.SET, NSWP.COM and FIND.COM. and
          transfer these files in the same way. You will now have 12 files on
          the M drive.
              Now place the blank formatted disc into the A drive and against
          the next asterisk type :-
              a:=m:*.*  ......press [RETURN] and see all the files on drive M
          transferred to the disc in drive A.   * is a WILDCARD symbol and for
          a number of commands, including PIP, can replace a filename or
          filetype, so *.* represents any file.  Wildcards and their uses are
          covered in the CP/M manual and elsewhere in this course, but now you
          can see why you needed to start from scratch with the M drive empty.
          This saved having to 'pip' each file separately.

              Well, that is your MALLARD BASIC Start-of Day disc. Put it into
          the A drive at boot-up and it will behave as promised in the first
          paragraph. First CP/M will load, then you will see all the action
          taking place on screen as PROFILE.SUB is run.If it doesn't check
          that all the named files are on the disc.
              Having run your Auto-load Start-of Day disc your machine will be
          set up as follows.
          1)  BASIC loaded, ready to go
          2)  The rightmost 15 keys will be set up to type common BASIC
              commands with a single key press plus [EXTRA] or [ALT] as
              detailed below
          3)  A number of useful files will be on the M drive, readily
              accessible from the A> prompt
          4)  Printing paper has been defined as 11" continuous, with a line
              spacing of 8 lines per inch and a gap of 6 lines.
          5)  The printer has been set to a small and economic typeface.

              These parameters can be changed or cancelled during a session,
          using the files on the M drive, which allows freedom to change discs
          in the A drive as and when you like. The machine becomes self-
          reliant.
              The various command lines used are described quite well in the
          CP/M manual supplied with your machine and it is well worth while
          spending some time finding out what can be done with utilities such
          as SETKEYS.COM, PAPER.COM, SETLST.COM and with the PROFILE.SUB file.
          However it is often difficult translating  written instructions into
          practical results and I hope that seeing the methods in action and
          noting the results will save hours of toil and not a little
          frustration.

          NSWP.COM
          ********   I have included NSWP.COM as well as PIP.COM because each
          complements the other. NSWP, once you get to know it, will prove
          invaluable and easier to use than PIP, but unlike PIP, cannot be
          used in a .SUB file to copy files etc.
          NOW - HOW DOES IT WORK ?
          ************************   When you put your Start-of Day disc into
          the A: Drive, it is the J14CPM3.EMS file which automatically boots
          CP/M. When it has done this it checks to see whether a file
          PROFILE.SUB is on the disc and if it is it is executed immediately
          with the help of SUBMIT.COM.
              PROFILE.SUB is a file which you make up using a text editor such
          as RPED and contains a list of CP/M command lines of your choice.
          These command lines are executed from the file instead of being
          typed in from the keyboard. As far as I am aware, any CP/M command
          lines can be added to PROFILE.SUB but they must, of course, make
          sense when used together.

              The PROFILE.SUB file that we used to make the Start of Day disc
          is reproduced below.

          setdef m:,*[order = (sub,com) temporary = m:]
          setkeys keys.mb
          paper 11, g6
          setlst printer.set
          pip
          <m:=basic.com[o]
          <m:=paper.com[o]
          <m:=setlst.com[o]
          <m:=printer.set
          <m:=setkeys.com[o]
          <m:=keys.mb
          <m:=pip.com[o]
          <m:=submit.com[o]
          <m:=nswp.com[o]
          <m:=find.com[o]
          <

          basic

          DEFINING THE SEARCH ORDER
          *************************   The first line (setdef etc.) defines the
          search order for files. It tells CP/M to look first in the M: drive
          and then in the default drive for a file, to look for a 'sub' file
          before a 'com' file and to use the M:drive for any temporary files.
          You will find that this means that you can call up a file on the M:
          drive even though you are in A: drive, and this also applies to the
          B: drive for those lucky enough to have a B: drive. Loading from the
          M: drive is, of course, much faster.
              The reason for specifying a 'sub' file first is that the 'sub'
          file is usually of more interest. For example to run RPED you would
          only need to type at the prompt A> rped    and the file RPED.SUB
          would be found and run as though you had typed A> submit rped . Try
          it!
              Finally, if you need to make a temporary file it would normally
          be saved to the default drive A: or B:, thus cluttering up that disc
          unnecessarily

          DEDICATING KEYS
          ***************   The second line (setkeys keys.mb) dedicates the 15
          keys to the extreme right of the keyboard to print commom BASIC
          keywords. To avoid interfering with the normal usage of these keys,
          [EXTRA] or [ALT] has to be pressed at the same time. The usage is as
          follows:-

          [EXTRA] + [RELAY] = print
          [EXTRA] + [.]     = tab()
          [EXTRA] + [ENTER] = data
          [EXTRA] + [1]     = input"  ",
          [EXTRA] + [2}     = line input "  ",
          [EXTRA] + [EOL]   = goto
          [EXTRA] + [5]     = gosub
          [EXTRA] + [CHAR]  = auto
          [EXTRA] + [FIND]  = list
          [EXTRA] + [PAGE]  = llist
          [EXTRA] + [PARA]  = renum
          [ALT]   + [CUT]   = basic
          [EXTRA] + [COPY]  = merge
          [ALT]   + [PASTE] = system

              [ALT] has been used for 'basic' and 'system' to avoid accidental
          use of these two powerful commands which can switch between CP/M and
          BASIC with the minimum of effort.
              Use of such key dedication can save a lot of typing time but
          care must be taken or unintended results will be found.
              Before starting an operation to dedicate keys we must have the
          following information;
              1) The key numbers; these are shown on page 109 of the manual.
              2) Which keys are to be dedicated
              3) What the dedicated keys are required to do in their new role.

          Any key can be dedicated to print any character in the range, or to
          print words, short phrases or control codes. In addition keys can
          print alone, with [SHIFT] or [ALT] or [EXTRA] or [SHIFT]+[ALT], so
          there is a wide choice.
              In the case we are considering, MALLARD BASIC, it was found that
          the rightmost block of 15 keys, when used with [EXTRA] would not
          interfere with any other action. In practice once BASIC and SYSTEM
          the command words to boot BASIC and return to CP/M were included,
          those keys were used with [ALT] to prevent accidental use with
          perhaps unfortunate consequences.
              As the keypresses were to print whole words, codes known as
          expansion tokens had to be used. There are 32 expansion tokens
          numbered in hexadecimal from #80 to #9F( see ASCII table.p116) but
          many are already taken up by control codes (see p112) and keys are
          dedicated to them. The first step was to decide which could be used
          .A look down the table yielded:-

              #80  Control-C   [STOP]   Essential, cannot be used!
              #81  Control-Z   [f1]
              #82  Control-Z   [f2]     As this is duplicated we can use it
          - and so on

              Continuing down the table it was decided that #82, #84, #86,
          #87, #88, #8B, #8D, #8F, #90, #97, #99, #9A, #9B, #9C, #9D, could be
          used, which gave us the 15 needed. Those that could not be used for
          example were  #89 Control-G [DEL], #91,#93,#94,#96 - Cursor codes. I
          hope that you get the idea.
              Using RPED a key definition file was compiled , KEYS.MB which
          allocated expansion tokens to the selected keys and then allocated
          BASIC commands to each expansion token .
              To allocate each expansion token to a key and define it takes
          two lines in the file. It doesn't matter in which order the lines
          are placed. Typical lines are :-

          01 E "^'#82'" ;Allocates exp.token #84 to [EXTRA]+key no. 01
          10 A "^'#9F'" ;Allocates exp.token #9F to [ALT]+key no. 10

              The first number is the key number, E represents [EXTRA], A
          represents [ALT], the remainder of the line specifies the expansion
          token. Key no. 01 is marked [RELAY],10 is marked [CUT]. ^ is printed
          by pressing [EXTRA]+U.

          E #82 "print"  ; Allocates string "print" to token #82
          E #82 "tab()"  ; Allocates string "tab()" to token #9F

              In these lines the E is mandatory and never changes. Very long
          strings can be allocated to a token, but as the total memory set
          aside for this purpose is limited, use of long strings will limit
          the number of tokens that can be used. If you want to include a
          comma or ^ in the string, they must be preceded by ^ ;
              E #86 "input ^"  ^""
              E #80 "^^C"  ; Control-C (STOP)

              I suggest that you take a look at KEYS.MB , KEYS.WP , AND
          KEYS.DRL to compare them with the above notes. One thing that you
          will see is that two lines are not necessary if either the expansion
          token or the key is allocated by default. Thus in KEYS.MB you will
          see some lines like ;
              77 N S "^'#9F'" ;

              This makes key no 77 (f7/f8) inoperative. N=normal,S=shift. Only
          one line is necessary because exp.token #9F has no value by default,
          and is kept for this purpose. It was done because f7 and f8 are
          allocated to #87 and #88 respectively and would print "data" and
          "rem" if this line were not inserted. No harm would be done but to
          me it would be untidy.
              The dedication of keys to characters and strings or phrases may
          seem complicated at first, but it is not really so. I hope that the
          foregoing will encourage you to investigate further and above all
          experiment. The worst that can happen is that if your first attempts
          are not quite right, which is probable, you may have to reboot CP/M
          to return to the status quo.If you want to experiment with KEYS.MB
          be sure to make a copy first in case you get lost. The simplest way
          to start is to put KEYS.MB into RPED or another text editor and
          change some of the strings;      e.g  line  E #82 "tab()" could be
          changed to E #82 "lprint".   You could then save your revised file
          under a different name such as KEYS.REV so as to keep KEYS.MB
          unchanged. You don't need to reboot CP/M each time you want to
          revise the key settings, but just type at the prompt;

              A> setkeys keys.rev   and all keys dealt with in your file will
          be upgraded to the new file settings.

              Dedicating the 15 rightmost keys as I have suggested brings the
          additional benefit that a piece of card can be taped to the end of
          the keyboard showing the words allocated to each key. Have fun !!

          SUMMARISING
          ***********

              Any recurring task that you perform on your computer will
          benefit from a Start of Day disc as this cuts out the boring bit at
          the start of a session; setting up and transferring files etc. I
          have tried in this section to take a practical approach by showing
          how to proceed step by step to make a S.o.D disc for MALLARD BASIC
          and then discussing the theory to enable you to make changes to suit
          your own preferences.
              One of the joys of computing is that there are usually so many
          alternative ways to perform each task and this allows creativity to
          be exercised. If you attempt something and fail, all you have lost
          is a little time, but you have gained in knowledge. Using your
          computer normally cannot do any damage to it. You have to do
          something really weird to do that like entering and changing the
          CP/M program, where if you were really careless or dead unlucky you
          might do some damage to a disc drive or printer by giving it
          damaging commands. You can alter CP/M from BASIC with the POKE
          command or with special software like SID, but by the time you are
          ready to use these facilities you will have learned enough to keep
          away from sensitive areas of CP/M. So enjoy experimenting as much as
          you like with BASIC; you have nothing to lose and a lot to gain.

          End of file  EXTRA.C
ing as much as
          you like with BASIC; you have nothing to lo