          MORE- SECTION C                                          FILE MORE.C
                                    COPYING PROGRAMS
                                    ****************
          Sooner or later you will want to copy a program listing from a book
          or magazine. I suggest that at first you confine yourself to
          listings which are specifically for the PCW8256/8512. These are to
          be found in magazines and books which cater solely for the
          PCW8256/8512. It is more difficult than it might appear to copy a
          listing correctly, and make it run, so your first attempts should be
          with short programs, until you have gained reasonable knowledge of
          BASIC,enabling you to tackle the almost inevitable 'debugging' with
          confidence.

          At first, failing to get a program to run, when you are sure that
          you have copied it exactly, may make you suspect a fault in the
          printed listing, but in my experience most magazine listings are
          printed correctly and the fault is more likely to be your own. Since
          even one misplaced punctuation mark may wreak havoc in a program,
          you have to be very accurate in your copying.

          Let's start with a few aids. Programs can be quite tedious to copy
          (which is why BASTUTOR saves you a lot of work and boredom in
          studying MALLARD BASIC), and it is better to type in longer programs
          in several sessions. Your copy program should be 'SAVED' regularly
          too, so that in the event of a power failure or other mishap you
          will not have lost too much work. Most programs start with line 10
          and so I start by typing the following four lines.

                  1 GOTO 4
                  2 PRINT "SAVEing *** PROGNAME.BAS *** ":SAVE "a:progname",a
                  3 STOP
                  4 REM

          Now if you type RUN in the ordinary way, the program will jump
          straight from 1 to 4 and then to the program proper. On the other
          hand if you type GOTO 2, a notice SAVEing *** PROGNAME.BAS *** will
          appear on the screen, then the program will be saved to disc under
          PROGNAME.BAS ( or whatever name you choose, of course, as long as it
          obeys the rules for filenames ( max. 8 letters or numerals etc.) The
          .BAS will be appended automatically. The a: before "progname" allows
          the program to be saved to the a: drive even from the m: drive if
          required. The ,a ensures that the program is saved in ASCII format,
          which makes for easier processing if required later. When the SAVING
          has been completed, the words BREAK IN 3 will appear on screen, then
          the Ok prompt, so that you can carry on. If you use this trick
          regularly, not only for copying, but also for your own programs, it
          will become second nature to type GOTO 2 at intervals, which can
          save a lot of heartache and aggro. You don't even have to remember
          the name of the program!

          Before you start, check the program line numbers. They will usually
          start at 10 and then go up in increments of 10. If they alter
          pattern from this, mark the deviating line numbers so that you can
          recognise them easily as you copy the program. Now is the time to
          call up the command AUTO.

          Type AUTO at the prompt and press RETURN and the number 10 will
          appear at the left-hand side ready for the first line to be typed
          in. After this has been done press RETURN again and the number 20
          will appear,ready for the second line . Each time RETURN is pressed
          a fresh number will appear, incrementing by 10. Although AUTO is
          intended primarily to generate line numbers for writing original
          programs, I find it invaluable when copying as it helps to keep
          track on lines as they are typed. To leave AUTO, first press RETURN
          to commit the current line to memory, then press STOP. This puts you
          back to the Ok prompt.

          WARNING  Do not use AUTO as described above with BASTUTOR or you
          =======  may damage the program by overwriting lines 10,20,30,etc.
          which are key lines performing important functions. However it is
          safe to experiment with lines from 50000 onwards whilst using the
          BASTUTOR course.

          To do this type AUTO 50000 and press RETURN several times. Numbers
          will appear at the left-hand side starting at 50000 and incrementing
          by 10. Press STOP then type AUTO 50500,5 . Line numbers will now
          start at 50500 and increment by 5. Try this in several combinations
          until you are sure how it works.

          If, whilst copying a program, you AUTO a line or lines which have
          already been entered, the whole line is presented, ready for editing
          if required. This can be very useful for 'DEBUGGING' and is
          discussed in this context in file MORE.D

          WIDTH  Most magazines have their program listings in lines shorter
          =====  than those of the standard screen. This doesn't worry me, but
          if you find it easier to make an exact copy ,the WIDTH command is
          used. Count the number of all characters across a full line
          including the digits of the line number and spaces; a common count
          is 40. Now before starting the program type WIDTH 40 at the prompt,
          press [RETURN]  and you will find that when you start copying, short
          lines of 40 characters will form. Of course this can be varied to
          make lines of any length up to the maximum of 90 characters. Try
          experimenting with this facility, using line numbers starting at
          50000. To return to normal length lines type WIDTH 90.There is no
          need to type lots of high quality prose to check this command. Just
          hold any key down so that it repeats for a line or two.

          Before starting to copy a program it is important that you make
          conditions as easy for yourself as possible. Some magazines make
          copying difficult by printing the listing in very small print, so
          that it becomes necessary to use a magnifying glass,particularly
          where it is necessary to distinguish between similar characters. At
          other times programs may be printed in colours which do not allow
          sufficient contrast for comfort. Access to a modern photo-copier is
          useful at these times as the program can be copied and enlarged.
          Contrast can often be improved also.

          A ruler or other straight edge can be used to indicate the line
          being copied. Even if you are an experienced typist, your prowess
          will be tested to the extreme by the strange juxtaposition of
          characters and symbols commonly encountered in programs. Although I
          can type ordinary prose reasonably efficiently, I am reduced to two
          fingers when typing in programs.

          If you are using the AUTO command to generate line numbers, check
          each line number before copying. It is easy to get out of step.

          Pay particular attention to look-a-like characters. The following
          are easily confused:

          0 and O
          1 and l and I
          8 and B
          ; and :
          , and .

          Other common errors are
                  1) Not copying brackets correctly- sometimes brackets come
                     in twos  ))
                  2) Leaving out punctuation marks.

          Even when simply copying it is useful to have some knowledge of
          BASIC, so as to be able to at least recognise Commands, functions,
          variables etc.,even though you may not understand how the program
          works. Commands and functions are invariably shown in upper case
          (Capital letters) because even if typed in lower case, BASIC
          converts automatically to upper case. This can be used to advantage.

          When listing, type in lower case, only using upper case where
          required for variables or text (most programmers use lower case for
          variables anyway). Then when you LIST, you will see that all the
          commands and functions will have been converted to upper case. If
          you find one that hasn't been converted, you have made a typing
          error; perhaps a mis-spelling or a space left out. This is a useful
          check and also makes typing easier.

          DATA is often entered in HEXADECIMAL and is a mixture of upper case
          letters and numbers. The easiest way to deal with this is to use the
          CAPITALS LOCK facility of your PCW. Press ALT + ENTER together, and
          thereafter upper case will be produced. However, unlike the use of
          the SHIFT LOCK key, numbers can still be typed. To cancel press ALT
          + ENTER again.

          Similarly ALT + RELAY acts as a NUMBER LOCK and enables the batch of
          keys at the right-hand side of the keyboard to be used as a number
          pad- useful in some instances if you are accustomed to using this
          facility.

          However careful you are, you are bound to make typong mistooks in a
          program of any length, and so it is absolutely necessary to save
          your work to disc regularly and immediately after completion.

          Sometimes a program will 'CRASH' when you try to run it. This means
          that none of the keys will have any effect and you have no
          alternative but to restart CP/M. Any part of the program that has
          not been saved to disc will thus be irretrievably lost.

          Having saved your hard work to disc you can then go to work to make
          it 'RUN' correctly, or 'Debug' it without fear of losing it.
          The first step is to make a hard copy of the program by typing LLIST
          at the BASIC prompt (First ensuring that you have paper in the
          printer), and compare this with the original listing. Incorrect
          lines can then be called up using the EDIT command and corrected.
          When this has been done don't forget to SAVE the revised program.

          Now is the time to cross your fingers and type RUN at the prompt.
          Sometimes it will run, but more often it will start to oblige then
          put a rude notice on the screen such as SYNTAX ERROR. Don't despair,
          because this is when you will add to your knowledge of BASIC.
          'DEBUGGING' can be very interesting and can develop into a battle
          between the cold logic of the computer and your growing skill and
          intuition. There is a tremendous satisfaction when you get a program
          to perform perfectly.


          END OF FILE MORE.C
 There is a tremendous satisfaction when you get a program
  