           SECTION D                                               File MORE.D
                                  DEBUGGING A PROGRAM
                                  ===================

          Having copied or written a program listing in any language it has to
          be put into a working state. The chance of copying a program of any
          length without making a mistake is remote, as is the possibility of
          writing a programme without errors first time. An error in a program
          is known as a "bug" and the process of removing bugs is known as
          debugging. Some bugs are hard to find and others may lie dormant in
          a program for some time, waiting for the right conditions, a
          particular sequence of keypresses perhaps, to show themselves. Even
          professional software contains bugs. These are usually not
          discovered when the program is first released, then as dozens or
          hundreds of purchasers begin to use the program, they appear. When
          the programmer is made aware of these problems a revised version
          will become available, which will usually  be issued on an exchange
          basis to previous purchasers, either free or for a small fee, to
          maintain confidence in the product. With a complicated program it
          can take several tries, maybe over months or even years before a
          product can deal with most eventualities without behaving in an
          eccentric manner. If you buy commercial software which misbehaves
          try to pinpoint the problem. e.g What sequence of keypresses
          triggers the bug; at what point in the program does it occur. etc.,
          then contact the Software house concerned for their help. A new
          version of a program is usually published, not solely because of
          bugs, but containing new or improved features, although every effort
          would be made at the same time to eradicate known bugs.
              Debugging programs in Mallard Basic is not too difficult,
          because several devices which help have been built into the Basic
          system itself. Mallard Basic is an 'interpreted' Basic as distinct
          from a 'compiled' Basic, which in practice means that each line is
          interpreted into machine code, which the computer understands, as it
          occurs. If there is an error in a line you will be told about it
          immediately it is interpreted, and you will then be able to correct
          it and resubmit it for immediate rerunning.
              With a compiled language errors are often accepted by the
          compiler, which turns the source program (the program that you have
          written) into a new program in a language understood by the computer
          but not easily by mankind. But if this program crashes when RUN you
          then have to find the error, correct the source code and recompile;
          a lengthy process. There are some languages which combine the best
          of both worlds, but until you possess one be thankful for MALLARD
          when debugging.

          SYNTAX   Any line that is not in correct SYNTAX will be rejected and
          ======   a message will appear on the screen to this effect. The
          message will depend on the way in which the line is written. If a
          command is written in direct mode and a syntax error is detected,
          perhaps a spelling mistake, then on pressing [RETURN] the message
          'Syntax error' will appear. In rare cases in program input mode the
          same thing can happen;  for example, if you start the line with a
          line number which is too large. But in general anything you write in
          program input mode will be accepted until you run the program then
          when a bad line is found the message ' Syntax error in 1500' will be
          shown and the offending line will be copied to the screen ready to
          be edited. Syntax errors can be quite difficult to spot sometimes,
          particularly in long lines, but the computer is never wrong, so keep
          looking!
              Typical syntax errors are;
                  1) incorrect spelling of keywords
                  2) incorrect use of spaces
                  3) wrong use or positioning of punctuation marks
                  4) using wrong but similar character ; l for 1, 0 for O, etc
                  5) incorrect use of brackets - there must be the same number
                     of opposite brackets ( and ) in a line .
                  6) illogical statements e.g  GOTO 340000 (line number too
                     big)
          TYPE MISMATCH  We have seen earlier in the course that variables
          =============  must agree in type to the values that they represent.
          for example a string must be represented by a string variable such
          as name$, where $ sets the variable type. A message 'Type mismatch
          in 1230' tells you that there is such an error in line 1230. The
          error may not be obvious, but I say again that if the computer
          reports an error, there is one. Sometimes you may find that the
          error is not confined to the line indicated, so check back on the
          previous usage of the variable.
                  Mallard Basic has other error messages which help in
          debugging and getting a program to run properly. These messages are
          covered in depth in the next section and should be read in
          conjunction with this text.
                  Suppose you have dealt with every error message and
          satisfied all the ground rules of Mallard Basic. As far as the
          computer is concerned the program is o.k, but you realise that it is
          not working properly. What can you do now ? Well, you are really on
          your own now, because at this stage debugging is down to experience
          and low cunning. What you have done is to write a program that the
          computer likes and is happy to run, but it doesn't do what you want.
          However, Mallard still has a few helpful tricks for you.

          TRON and TROFF These two commands allow you to trace the sequence in
          ============== which lines are executed. Type TRON at the prompt and
          press [RETURN], then when the program is run the line sequence is
          displayed as the program unfolds. Use TROFF similarly to shut down
          this facility. You can check many things by examining line sequence;
          whether loops are running correctly, or if subroutines are being
          called ,etc. It is easy to accidentally jump over a key line or to
          run lines twice.
              You can use [STOP] to halt the program as required to examine
          the program at crucial points and then start them again by typing
          CONT. (provided that you haven't altered the program)
              TRON is a very powerful debugging tool and must never be
          overlooked.

          REM, STOP, END  These keywords can be placed temporarily in a
          ==============  program to assist in debugging.
               REM placed at the start of a line will stop the line executing;
          very useful on occasions. One particular use is to prevent clearing
          the screen whilst using TRON. Clearing the screen obviously wipes
          off all the line numbers thus far assembled by TRON.
              STOP or END added to the program will enable part only of a
          program to be run.This can also be used to good advantage with TRON.

          Variables  It is often necessary to know the value of a variable at
          =========  a given time. Values of variables, once determined, are
          stored in the computer's memory and updated as they change. The
          latest values can be printed out at any time by simply typing
          PRINT a$, where a$ is the variable. A tremendous amount can be
          deduced from this, particularly if you STOP the program at intervals
          as described above to see what is happening to key variables. In
          this context you will quickly discover the worth of GOTO to start a
          program, instead of RUN, as RUN wipes the slate clean and zeros all
          variables.

           Why not try some of the above tricks now, to see how they work?
          ===============================================================

          EXTRA, section g), side 4 of this course, is designed  to give you
          some practice in debugging. It gives access to files which
          containprograms which are written twice, the first time correctly,
          the second time deliberately bugged. What you have to do is to run
          the first listing to see what the program does, then go on to debug
          the second so that it runs as well as the first. Instructions are
          given with each program including how to easily compare the same
          lines from each listing if you need help.

          End of MORE.D
gram including how to easily compare the same
          lines from each listin