          SECTION F                                               FILE  MORE.F
                                   ADVANCED EDITING
                                   ****************

              Editing a line of program simply means altering it in some
          way. Mallard BASIC makes editing very easy to do which is fortunate
          as you will be doing a lot of it, both within this course and when
          you write your own programs.
              This file discusses ways of adding and altering lines using
          short cuts and doing as little typing as possible. There is no glory
          in doing more work than you have to. The end product is all that
          matters. If you practice and constantly try the various methods
          shown below as they seem relevant, you will be able to call on them
          instinctively when required. Believe me, this file is worth studying
          and getting to grips with.
          ********************************************************************

               The text following this paragraph assumes that you are using
          the BASIC environment to edit your programs. This is not essential
          because if programs are saved in ASCII format as has been described
          in other files, then they can be loaded into a suitable text editor
          or word processor and edited there. In fact whole programs can be
          written in a word processor in BASIC format, and if correct can be
          called up into the BASIC environment and run. If you want to try it
          you may find that LOCOSCRIPT is not very suitable because of the
          nuisance of converting to ASCII and swapping 'sides', but I have
          done it.  Short programs can be accommodated by RPED, given free
          with your PCW and is worth a try.  Advocates of this method find
          freedom by not being confined to one line but can dodge about the
          screen at will. You  can use any other facilities offered by the
          word processor you use, but lose many of the special facilities that
          the BASIC environment offers.
              Using a word processor or editor to write a program is necessary
          for compiled programs but my opinion is that for interpreted BASIC
          it's not worth the hassle. Still, try it- you may prefer it.
          *******************************************************************

              RETURNING to the BASIC environment, we have already seen that a
          line of BASIC needs to be in the state that I have called EDIT MODE
          before it can be edited. At this time the cursor is on the line and
          can be moved about the line by means of the four arrow keys at the
          left-hand side of the keyboard. If the program 'line' occupies more
          than one line on the screen you will find that the cursor can be
          moved up and down within the confines of the line as well as left
          and right.  Any alteration can only be made at the cursor position.

          ADDING or CHANGING CHARACTERS  Characters, including spaces, can be
          =============================  added at the cursor position by
          operation of the keyboard in the usual way. Spaces are added by
          using the SPACE BAR. They can be added in two modes, INSERT
          and OVERSTRIKE. The default is INSERT mode; that is when a key is
          pressed the character goes into the line at the cursor position and
          the rest of the line moves up to make room for it.

           PRESSING THE [+] KEY WHEN IN EDIT MODE ENTERS OVERSTRIKE MODE. In
          this case a character entered at the cursor position REPLACES the
          existing character. This can be a useful and neat way of editing in
          some cases but needs a little practice. Overstrike mode is cancelled
          either by pressing the [+] key again or when RETURN is pressed. In
          other words it has to be positively selected whenever it is required
          by 'toggling' the [+] key. Insert mode is the default.

          DEL KEYS  Characters can be deleted by using the keys marked DEL
          ========  forwards or backwards along the line as needed. Single
          presses will delete one character, but if a DELete key is held down
          it will continue to gobble up characters until released or until
          there are no more reachable characters. Remember that spaces are
          characters also and you will find that they can be removed with the
          DEL keys when required. This is often necessary when positioning
          text.See below.

          USE OF SPACE BAR, DEL KEYS AND CURSOR KEYS  The space bar causes the
          ==========================================  cursor to move across
          the screen from left to right. Any characters on the line will be
          pushed along in front of the cursor. This is an illusion in that the
          characters are not being pushed along but are having spaces inserted
          in front of them. Similarly the right-hand DEL key seems on occasion
          to be able to move characters from right to left, but what it is
          really doing is deleting spaces. The cursor keys, on the other hand
          neither make nor delete spaces, but simply indicate the position on
          the screen where printing can occur.
              If you don't realise this you may be puzzled if the characters
          you are typing don't act as you expect. If you have not formed a
          space in a line with the space bar, but have simply used the cursor
          key, any characters that you type will move to the left until they
          meet another character. This could lead, if not noticed, to a syntax
          error, so bear this point in mind.
              When you bring up a line for editing, the cursor always appears
          over to the left hand side. This is annoying if you need to alter
          something near the far end of the line. By pressing the [FIND] key
          TWICE the cursor will leap to the end of the line. Unfortunately, I
          have found no way to make it leap back again -yet. [FIND] can also
          be used to move along a line, but only from left to right. Press
          [FIND], then select a letter and press it. The cursor will jump to
          the first incidence of that letter.
              Another tip is that by pressing the [CUT] key twice, all
          characters to the right of the cursor on that line will be deleted.

          LINE NUMBERS        Anything in a program line can be changed,
          ============        including the line number, but be very careful
          about changing the line number as it can have a great effect on the
          program. If you change the line number to one that is already used
          in the program, on pressing RETURN  the edited line will replace
          that line, which will be lost. In addition the original line will
          remain valid, so that you could finish up with two identical lines
          with different line numbers. These effects are, however, very useful
          when used deliberately.

          DELETING WHOLE LINES   If you wish to delete a program line and you
          ====================   know the line number, from DIRECT MODE simply
          type the number alone then press RETURN and the line will cease to
          exist.
              What has happened is that by typing the number you immediately
          entered EDIT mode, and by pressing RETURN you set that line into
          memory, replacing the old line of the same number. However, a line
          number cannot exist alone and so is removed from memory.

          ADDING IDENTICAL OR SIMILAR LINES   Very often identical or near-
          =================================   identical lines are required in
          a program. Suppose you have a line number 1300, which you wish to
          reproduce at line 2500. Type EDIT 1300 to call the line up,change
          the line number to 2500 then press RETURN. The program now contains
          two lines 1300 and 2500 which are identical. The same applies if the
          two lines are to be similar but not identical. Always change the
          number first before editing the rest of the line, because if you
          forget and press RETURN before the number is changed, the old line
          will be replaced by the newly edited line and you will lose it. This
          method of creating new lines is extremely useful and saves a
          trmendous amount of typing.
              Another neat trick to construct similar lines is by copying .
          You can write a line, or if the line is already written call it up
          with the EDIT command, press [RETURN] then immediately press the
          cursor left arrow key. You will see the line reappear ready for
          editing. This is the ideal way to prepare a number of similar lines,
          for example a menu or a table. Remember, though to alter the line
          numbers first or you could get into a muddle.

          AUTO EDITING  This method of calling up lines is a favourite of mine
          ============  whenever a number of lines at equal intervals need
          editing. AUTO is strictly a command word to produce line numbers
          automatically for writing or copying programs. In DIRECT COMMAND
          mode if you type AUTO and press return you will be rewarded by the
          line number 10 appearing at the left-hand side of the screen ready
          for a line to be typed in. Each time RETURN is pressed another
          number will appear in increments of 10; 10,20,30,40 etc. But the
          nice thing is that if any of these line numbers are already being
          used, the whole line will be displayed ready for editing.
               AUTO can start at any line number and increase in any
          increment. By typing AUTO alone you simply select the standard
          (default) setting . AUTO 200 will start line numbers at 200 with
          increments of 10, whereas AUTO 2500,5 (note the comma) will start
          numbers at 2500 and increase in increments of 5; 2500,2505,2510,2515
          etc.
              The use of this may not be apparent at this point, but it is in
          fact a most useful facility, as it not only brings up lines for
          editing with little effort, but it brings them up immediately one
          below the other, enabling things like menus to be tidied and lined
          up with ease. I always bear this in mind when writing a program and
          considering suitable line numbers.
              To escape from AUTO, edit your last line, press RETURN, then
          press STOP when you will return to DIRECT MODE.

          SAVING TIME ON TYPING
          =====================   When writing a BASIC program much of what
          you type is repetition. Most programs need an initialising module to
          set up codes for clearing the screen, entering reverse video, etc.
          If you find yourself writing programs in which identical or similar
          modules are used, such as menus, subroutines etc., write them once
          then save them separately with meaningful file names. Then when you
          need them you can renumber the lines, if necessary, with RENUM and
          MERGE them into your latest masterpiece. You don't need to write
          them specially; they can be edited to suit the new program. On the
          other side of this disc are short programs which you can adapt for
          insertion into your own programs.

              When writing programs you have to type the same words over and
          over again. If you enjoy it indulge yourself, but if you think it a
          waste of time and effort there is a way round the problem by
          dedicating keys not used in BASIC to print out common words or
          phrases at the press of a single key. The method is discussed in the
          section on making a Start-of Day disc.

          END OF FILE MORE.F
 single key. The method is discussed in the
          section on m